//background.js

//add current page
chrome.browserAction.onClicked.addListener(function(){
	
	
	//get user id from cookie and pass to content script
	Storage.getUserId(function(userId){
		//console.log(userId);
		//return false;
		
		chrome.tabs.query({active:true,currentWindow:true},function(tabs){
			var tab_url = tabs[0].url;
			var tab_id = tabs[0].id;
			var tab_title = tabs[0].title;
			
			var message = {
				type:"ADD_PAGE",
				data : {
					url : tab_url,
					title : tab_title
				},
				userId : userId
			};
			
			chrome.tabs.sendMessage(tab_id,message);
		})
		
	})
	
	
	
});




//add current page same to browser action button
var contextMenuPage = {
    id:"addPage",
    title:chrome.i18n.getMessage("contextMenuSavePage"),
	contexts: ['page']
}
chrome.contextMenus.create(contextMenuPage);

//add selection text 
var contextMenuSelection = {
	id : "addSelectionText",
	title : chrome.i18n.getMessage("contextMenuSaveSelection"),
	contexts : ['selection']
};
chrome.contextMenus.create(contextMenuSelection);

//add context links
var contextMenuLink = {
	id : "addLink",
	title : chrome.i18n.getMessage("contextMenuSaveLink"),
	contexts : ['link']
};
chrome.contextMenus.create(contextMenuLink);

//add context image
var contextMenuImage = {
	id : "addImage",
	title : chrome.i18n.getMessage("contextMenuSaveImage"),
	contexts : ['image']
};
chrome.contextMenus.create(contextMenuImage);

//encapsulate the message and user info ,then send it to content script
chrome.contextMenus.onClicked.addListener(function(info,tab){
	
	var message = {};
	
	switch(info.menuItemId){
		case "addPage":
			message = {
				type:"ADD_PAGE",
				data : {
					url : tab.url,
					title : tab.title
				}
			}
			break;
		case "addSelectionText":
			message = {
				type:"ADD_TEXT",
				data : {
					url : info.pageUrl,
					text : info.selectionText
				}
			};
			break;
		case "addLink":
			message = {
				type:"ADD_LINK",
				data : {
					url : info.linkUrl
				}
			};
			break;
		case "addImage":
			message = {
				type:"ADD_IMAGE_LINK",
				data : {
					url : info.srcUrl,
					title: tab.title,
					context_url:info.pageUrl
				}
			};
			break;
		
	}
	
	
	Storage.getUserId(function(userId){
		message.userId = userId;
		chrome.tabs.sendMessage(tab.id,message);
	})
	
	
});


//on receive tabs message
//message.type : 
//message.data : any
chrome.runtime.onMessage.addListener(function(message,sender,sendResponse){
	//console.log("[SHOUQU] Extention on message: ",message);
	
	//var cookieOption = {};
	switch(message.type){
		case "SET_COOKIE":
			Storage.setCookie(message.data,sendResponse);
			break;
		case "DELETE_COOKIE":
			Storage.deleteCookie(message.data.name,sendResponse);
			break;
		case "GET_COOKIE":
			Storage.getCookie(message.data.name,(res) => {console.log(JSON.stringify(res));sendResponse(res)});
			break;
	}
	
	//This function becomes invalid when the event listener returns, unless you return true from the event listener to indicate you wish to send a response asynchronously (this will keep the message channel open to the other end until sendResponse is called).
	//reference : https://developer.chrome.com/extensions/runtime#event-onMessage
	return true;

});

