//直接向页面注入批量导入对话框组件
$(function(){
	
	//fitscreen方法让元素铺满整个body
	$.fn.fitScreen = function(){
		var _width = document.body.clientWidth > document.documentElement.clientWidth ? document.body.clientWidth : document.documentElement.clientWidth;
		var _height = document.body.clientHeight > document.documentElement.clientHeight ? document.body.clientHeight : document.documentElement.clientHeight;
		var jrtt_ywrap = $(".y-wrap").get(0);
		if(jrtt_ywrap){
			_height = jrtt_ywrap.clientHeight + 24;
		}
		$(this).css({"width": _width,"height":_height});
		return $(this);
	};
	
	//fixCenter方法让元素居于屏幕中央
	$.fn.fixCenter = function(){
		var _width = document.body.clientWidth < document.documentElement.clientWidth ? document.body.clientWidth : document.documentElement.clientWidth;
		var _height = document.body.clientHeight < document.documentElement.clientHeight ? document.body.clientHeight : document.documentElement.clientHeight;
		var _left = ( _width - $(this).width() ) / 2;
		var _top = ( _height - $(this).height() ) / 2;
		$(this).css({"left":_left,"top":_top});
		return $(this);
	};

	
	//对话框既是界面，也是整个导入组件
	function Importer(){
		
		//the importing status,0:ready;1:importing,2:paused
		this.importStatus = 0; 
		
		//存储所有解析链接
		this.totalLinks = [];
		
		//存储总数量
		this.totalCount = 0;
		
		//存储中断位置
		this.pausedPosition = null;
		
		//存储来源ID
		this.sourceID = null;
		
		//ajax
		this.ajax = null;
		
		
		var dialog_html = '<div id="sq_batch_dialog_import" class="sqext-modal-dialog">\
			<h1 class="dialog-title">将<strong class="transact-source-name"></strong>中的收藏导入<strong>收趣</strong></h1>\
			<div class="dialog-body">\
				<div class="transact">\
					<div class="transact-imgwrap"><img src="" class="transact-source-img transact-logo" /><span class="transact-source-name"></span></div>\
					<div class="transact-imgwrap"><img src="' + chrome.extension.getURL("images/transact-arrow@3x.png")+'" class="transact-img-arrow" /></div>\
					<div class="transact-imgwrap"><img src="' + chrome.extension.getURL("images/128.png")+'" class="transact-target-img transact-logo" /><span class="transact-target-name">收趣</span></div>\
				</div>\
				<div class="sq-percent-bar-wrap">\
					<div class="sq-percent-text"><span class="sq-percent-status">准备导入</span><span class="sq-percent-result">总共导入<span class="sq-percent-count"></span>个书签</span></div>\
					<div class="sq-percent-bar"><div class="sq-percent-bar-blue"></div></div>\
				</div>\
				<ul>\
					<li>注意：</li>\
					<li>1.导入时请不要关闭页面，如果您的要导入的书签较多，请耐心等待</li>\
					<li>2.一旦看到导入完成，您的书签就已保存在收趣，但仍需要一段时间解析后才能在App中看到。</li>\
				</ul>\
				<div class="sq-dialog-button-group">\
					<a href="#" id="start_btn" class="sq-btn-primary sq-btn">开始</a>\
					<a href="#" id="complete_btn" class="sq-btn-primary sq-btn hidden">完成</a>\
					<a href="#" id="cancel_btn_pre" class="cancel-btn sq-btn-nobg sq-btn">取消</a>\
				</div>\
				<div class="sq-dialog-mask hidden sq-dialog-mask-interrupt">\
					<div class="sq-already-count"><h3>已经导入<i class="sq-import-count"></i>条，确定要取消？</h3></div>\
					<div class="sq-dialog-button-group">\
						<a href="#" id="resume_btn" class="sq-btn-primary sq-btn">继续导入</a>\
						<a href="#" id="cancel_btn_sure" class="cancel-btn sq-btn-nobg sq-btn">取消导入</a>\
					</div>\
				</div>\
			</div>\
		</div>';
		
		//对话框对象
		this.dialog = $(dialog_html).appendTo('body');
		
		//遮罩对象
		var mask_html = '<div class="sqext-mask" style=""></div>';
		this.mask = $(mask_html).appendTo('body');
		
		//refrence to the instance
		var that = this;
		
		//handlers
		this.startClickHandler = function(){
			that.run();
		}
		this.breakupClickHandler = function(){
			that.pause();
		}
		this.cancelClickHandler = function(){
			that.cancel()
		}
		this.resumeClickHandler = function(){
			that.run()
		}
		this.completeClickHandler = function(){
			that.init();
		}
		
		
		//添加屏幕缩放支持
		$(window).on('resize',function(){
			that.dialog.fixCenter();
			that.mask.fitScreen();
		});
	}
	
	//显示对话框
	Importer.prototype.show = function(){
		
		this.mask.fitScreen().show();
		this.dialog.fixCenter().show();
	}
	
	//设置来源信息
	Importer.prototype.setSource = function(source_id){
		//设置来源ID属性
		this.sourceID = source_id;
		
		var sourceLogo,sourceName;
		switch(source_id){
			case "JRTT":
				sourceLogo = chrome.extension.getURL("images/toutiao-logo.png");
				sourceName = "今日头条";
				break;
			case "ZHHU":
				sourceLogo = chrome.extension.getURL("images/zhihu-logo.png");
				sourceName = "知乎";
				break;
			case "INPR":
				sourceLogo = chrome.extension.getURL("images/insta-logo.png");
				sourceName = "Instapaper";
				break;
		}
		this.dialog.find(".transact-source-name").text(sourceName);
		this.dialog.find(".transact-source-img").attr("src",sourceLogo);
	}
	
	//初始化
	Importer.prototype.init = function(){
		
		//恢复对话框状态到ready
		this.importStatus = 0;
		this.totalCount = 0;
		this.pausedPosition = null;
		this.totalLinks = [];
		
		//绑定事件
		this.dialog.find("#start_btn").unbind().bind("click",this.startClickHandler);
		this.dialog.find(".cancel-btn").unbind().bind("click",this.cancelClickHandler);
		this.dialog.find("#resume_btn").unbind().bind("click",this.resumeClickHandler);
		this.dialog.find("#complete_btn").unbind().bind("click",this.completeClickHandler);
		
		//恢复遮罩层状态
		this.dialog.find(".sq-dialog-mask-interrupt").addClass("hidden").find(".sq-import-count").text('');
		this.dialog.find("#start_btn").show();
		this.dialog.find("#cancel_btn_pre").show();
		
		//设置来源信息
		if(window.location.host.match(/zhihu.com/)){
			this.setSource('ZHHU');
		}else if(window.location.host.match(/toutiao.com/)){
			this.setSource('JRTT');
		}else if(window.location.host.match(/instapaper.com/)){
			this.setSource('INPR');
		}
		
		//隐藏mask
		this.mask.hide();
		
		//隐藏对话框并将对话框中的元素复位
		this.dialog.find(".sq-percent-count").text('');
		this.dialog.find(".sq-percent-result").hide();
		this.dialog.find(".sq-percent-bar-blue").removeClass("sq-moving-bar").css({width:'25px',left:'-25px'});
		this.dialog.find(".sq-percent-status").show().text("准备导入");
		this.dialog.find(".transact-img-arrow").attr("src",chrome.extension.getURL("images/transact-arrow@3x.png"));
		this.dialog.find("#start_btn").text("开始").removeClass("disabled").show();
		this.dialog.find("#complete_btn").addClass("hidden");
		
		//隐藏对话框
		this.dialog.hide();
	}
	
	//开始分析页面并启动解析程序
	Importer.prototype.run = function(){
		
		//改状态
		this.importStatus = 1;
		
		//改效果
		this.dialog.find(".sq-dialog-mask-interrupt").addClass("hidden").find(".sq-import-count").text('');
		this.dialog.find("#start_btn").show();
		this.dialog.find("#cancel_btn_pre").show();
		
		this.dialog.find(".sq-percent-status").text("导入中");
		this.dialog.find(".transact-img-arrow").attr("src",chrome.extension.getURL("images/transact-arrow@3x.png"));
		this.dialog.find("#start_btn").text("导入中，请稍候...").addClass("disabled").unbind();
		this.dialog.find('.sq-percent-bar-blue').addClass('sq-moving-bar');
		
		//根据所在页面启动对应的解析程序
		var url = window.location.href;
		var protocol = url.split("//")[0],path = url.split("//")[1];
		var host = path.substring(0,path.indexOf('/')),
			pathname = path.indexOf("?") != -1 ? path.substring(path.indexOf('/'),path.indexOf("?")) : path.substring(path.indexOf('/')),
			search = url.indexOf("?") != -1 ? url.substring(url.indexOf("?")) : "";
		var locationObj = {
			protocol:protocol,
			host:host,
			pathname:pathname,
			search:search,
			href:url
		}
		
		if(this.sourceID === 'ZHHU' && pathname.indexOf("/collection/") != -1){
			this.parseZHHU(locationObj)
		}else if(this.sourceID === 'JRTT' && pathname.match(/user\/\d+\//g) != -1){
			this.parseJRTT(locationObj)
		}else if(this.sourceID === 'INPR' && pathname.match(/u|videos|liked|starred|archive|folder/g)){
			this.parseINPR(locationObj)
		}
		
	}
	
	//暂停
	Importer.prototype.pause = function(){
		this.importStatus = 2;
		//console.log(this.pausedPosition);
		//this.ajax.abort();
		this.dialog.find(".sq-dialog-mask-interrupt").removeClass("hidden").find(".sq-import-count").text(this.totalCount);
		this.dialog.find("#start_btn").hide();
		this.dialog.find("#cancel_btn_pre").hide();
	}
	
	//完成
	Importer.prototype.complete = function(){
		this.importStatus = 0;
		//改对话框效果
		this.dialog.find(".sq-percent-status").text("导入完成");
		this.dialog.find(".sq-percent-result").show();
		this.dialog.find(".sq-percent-count").text(this.totalCount);
		this.dialog.find("#start_btn").hide();
		this.dialog.find("#complete_btn").removeClass('hidden');
		this.dialog.find('.sq-percent-bar-blue').removeClass('sq-moving-bar').css({width:'100%',left:0});
		this.dialog.find("#cancel_btn_pre").hide();
	}
	
	//取消
	Importer.prototype.cancel = function(){
		
		if(this.importStatus != 1){
			this.init();
		}else{
			this.pause();
		}
	}
	
	//解析知乎页面数据
	Importer.prototype.parseZHHU = function(loc){
		//console.info("正在解析知乎页面");
		
		//reference to instance
		var that = this;
		
		//默认从第一页开始解析，当有中断时从中断位置开始
		if(this.pausedPosition !== null){
			parsePage(this.pausedPosition)
		}else{
			parsePage(1);
		}
		
		//解析知乎页面数据并提交
		function parsePage(page){
			
			that.pausedPosition = page;
			var url = loc.protocol + "//" + loc.host + loc.pathname + "?page=" + page;
			
			//如果处于暂停状态，则停止解析
			if(that.importStatus != 1){
				//that.pausedPosition = page;
				return false;
			}
			
			this.ajax = jQuery.ajax({
				url:url,
				dataType:'html',
				method:'get',
				success:function(res){
					//匹配知乎页面所有问题链接，包括知乎专栏的链接
					var parsed_str = res.match(/<h2 class="zm-item-title"><a(.*)href="(.*)"(.*)>/g);
					var links = [];//links在1.2.4之前仅传url,以后版本传入标题，帮助服务解析
					for(var k=0; k < parsed_str.length; k++){
						if(parsed_str[k].match(/http/g)){
							var obj = {
								url : parsed_str[k].match(/(http|https):\/\/([\w-]+\.)+[\w-]+(\/[\w- ./?%&=]*)?/g)[0],
								title : $(parsed_str[k]).text()
							}
							links.push(JSON.stringify(obj));
							
							//links.push(parsed_str[k].match(/(http|https):\/\/([\w-]+\.)+[\w-]+(\/[\w- ./?%&=]*)?/g)[0])
							
						}else{
							var obj = {
								url : loc.protocol + "//" + loc.host + parsed_str[k].match(/\/question\/\d+/g)[0],
								title : $(parsed_str[k]).text()
							}
							links.push(JSON.stringify(obj));
							
							//links.push( loc.protocol + "//" + loc.host + parsed_str[k].match(/\/question\/\d+/g)[0] );
						}
						
					}
					links = $.unique(links);
					//先找出重复项，再去掉重复项
					links = links.diff(links.dup(that.totalLinks));
					//对总数组与当前数组进行diff运算，应该在提交成功后再记录
					//that.totalLinks = that.totalLinks.concat(links);
					
					//console.log("当前页解析结果：",links);
					//console.log("总解析结果：",that.totalLinks);
					//console.info("已解析:%d条",that.totalCount)
					//如果有多页并且当前页不是最后一页则继续加载，否则只加载当前页
					var is_multipage = res.match(/zm-invite-pager/g) != null;
					var is_lastpage = res.match(/<a(.*)>\u4E0B\u4E00\u9875<\/a>/g) == null;
					if(is_multipage && !is_lastpage){
						that.batchSubmit(links,function(){
							that.totalLinks = that.totalLinks.concat(links);//添加成功后再做记录，否则会出现漏加暂停时的页面
							that.totalCount += links.length;
							parsePage(++page);
						})
					}else{
						that.batchSubmit(links,function(){
							that.totalLinks = that.totalLinks.concat(links);//添加成功后再做记录，否则会出现漏加暂停时的页面
							that.totalCount += links.length;
							that.complete()
						})
					}
					
				}
			});
		}
	}
	
	//解析今日头条页面数据
	Importer.prototype.parseJRTT = function(loc){
		//console.log("parse JRRT");
		
		//reference to instance
		var that = this;
		
		//默认从第一页开始解析，当有中断时从中断位置开始
		if(this.pausedPosition !== null){
			repinData(this.pausedPosition)
		}else{
			repinData(0);
		}
		
		function repinData(time){
			
			
			that.pausedPosition = time;
			
			//var url = loc.protocol + "//" + loc.host + "/api/favorites/?count=20&max_repin_time=" + time +'&app_name=news_article';
			
			var user_id = location.pathname.match(/\d+/g)[0];
			var url = loc.protocol + "//" + loc.host + "/c/user/favourite/?page_type=2&user_id=" + user_id + "&max_behot_time=0&count=20&max_repin_time=" + time
			
			//如果处于暂停状态，则停止解析
			if(that.importStatus != 1){
				return false;
			}
			
			this.ajax = jQuery.ajax({
				url:url,
				method:'get',
				success:function(res){
					var data = res.data,len = data.length,links = [];
					if(len){
						
						for(var i =0 ;i < len;i++){
							links.push(data[i].display_url);
							time = data[i].user_repin_time;
						}
						
						links = $.unique(links);
						//先找出重复项，再去掉重复项
						links = links.diff(links.dup(that.totalLinks));
						//对总数组与当前数组进行diff运算
						
						
						//console.log("分批解析：",links);
						that.batchSubmit(links,function(){
							that.totalLinks = that.totalLinks.concat(links);
							that.totalCount += links.length;
							repinData(time);
						});
					}else{
						
						that.complete();
					}
				}
			})
			
			
		}
	}
	
	//解析Instapaper
	Importer.prototype.parseINPR = function(loc){

		var $unread_nav = jQuery("#unread_nav");
		var $liked_nav = jQuery("#liked_nav");
		var $archive_nav = jQuery("#archive_nav");
		var $videos_nav = jQuery("#videos_nav");
		var $folders = jQuery("#folders");
		
		var pages = [];
		var rss_urls = [];
		
		pages.push(window.location.protocol + "//" + window.location.host + $unread_nav.attr("href"));
		pages.push(window.location.protocol + "//" + window.location.host + $liked_nav.attr("href"));
		pages.push(window.location.protocol + "//" + window.location.host + $archive_nav.attr("href"));
		pages.push(window.location.protocol + "//" + window.location.host + $videos_nav.attr("href"));
		$folders.find(".folder_link").each(function(){
			pages.push(jQuery(this).attr("href"));
		})
		//console.log(pages);
		//return false;
		
		function getRssUrlByPage(page_index,callback){
			jQuery.ajax({
				url : pages[page_index],
				success: function(result){
					//分析result string,取出link的href值
					var valid_links = result.match(/<link rel="alternate" type="application\/rss\+xml" title="RSS" href="(.*)" \/>/g);
					//console.log(valid_links);
					if(valid_links.length > 0){
						var url = valid_links[0].match(/\/rss\/[0-9]+\/(.*)"/g)[0];
						url = url.substring(0,url.lastIndexOf('"'));
						rss_urls.push(url);
					}
					
					//分析下一个
					if(page_index < pages.length){
						getRssUrlByPage(page_index + 1)
					}
					
				}
			})
		}
		
		getRssUrlByPage(0);
		//console.log(rss_urls);
		return false;
		
		var that = this;
		var rss_link = jQuery("link[type='application/rss+xml']");
		var rss_url = window.location.protocol + "//" + window.location.host + rss_link.attr("href");
		if(rss_url){
			this.ajax = jQuery.ajax({
				url : rss_url,
				dataType : "xml",
				success : function(xml){
					var links = [];
					$(xml).find("item").each(function(i,v){
						links.push($(v).find("link").text());
					});
					if(links.length > 0){
						if(that.pausedPosition !== null){
							importLink(links,that.pausedPosition)
						}else{
							importLink(links,0)
						}
					}else{
						that.complete();
					}
					
				},
				error : function(jqXHR,textStatus,errorThrown){
					console.log(textStatus)
				}
			})
		}else{
			that.complete();
		}
		
		//执行导入
		function importLink(links,index){
			that.pausedPosition = index;//记录当前暂停位置，即item的index值
			var lk = links[index];
			if(typeof lk != "undefined"){
				var link = [lk];
				
				that.batchSubmit(link,function(){
					that.totalCount += 1;
					importLink(links,++index);
				});
			}else{
				that.complete();
			}
			
		}
	}
	//批量提交到收趣
	Importer.prototype.batchSubmit = function(urls,callback){
		var objData = {
			userId: userInfo.userId,
			urls: urls,
			channel:CHANNEL_ID_BATCH
		}
		//如果处于暂停状态，则停止提交
		if(this.importStatus != 1){
			return false;
		}
		if(urls.length > 0){
			this.ajax = jQuery.ajax({
				url:API_BATCH_IMPORT,
				data:objData,
				method:'post',
				success:function(res){
					if(callback){
						callback();
					}
				},
				error:function(jqXHR,textStatus,errorThrown ){
					console.log(textStatus);
				},
				complete: function(XMLHttpRequest,status){ //请求完成后最终执行参数
					if(status=='success'){//超时,status还有success,error等值的情况
						//console.log("ajax request success");
					}else{
						//console.log(status)
					}
				}
			})
		}else{
			if(callback) callback();
		}
	};
	
	//用户cookie全局
	var userInfo = {};
	
	//操作对话框
	var importer = new Importer();
	importer.init();
	
	//floatBtn 作为启动对话框的隐藏按钮插入页面
	var $floatBtn = $('<div class="sq-import-btn-wrap hidden"><img class="sq-import-btn-logo" src="'+ chrome.extension.getURL("images/import-bar-logo.png") +'" /><span class="sq-import-btn">导入到收趣</span></div>').appendTo("body");
	$floatBtn.click(function(){
		//console.clear();
		
		//重置user_cookie
		userInfo = {};
		
		//强制mask适应当前页面
		importer.mask.fitScreen();
		
		//从扩展获取登录信息，如果未登录则显示登录界面
		var message = {
			type:'GET_COOKIE',
			data : {
				name : "userId"
			}
		}
		//console.log(chrome.runtime.id);
		chrome.runtime.sendMessage(chrome.runtime.id, message, function(res){
			//console.log("user cookie info:",res);
			//var cookies = res.cookies;
			if(res && res.value){
				userInfo.userId = res.value;
				importer.show();
			}else{
				UI.hide().showSignin();
			}
			
		});
		
	});
	
	//根据环境确定是否显示floatBtn
	if(
		(window.location.host === "www.zhihu.com" && window.location.pathname.match(/collection\/\d+/g) !== null) 
		|| 
		(window.location.host === "www.toutiao.com" && window.location.pathname.match(/\/user\/\d+\//g) !== null)
		|| 
		(window.location.host === "www.instapaper.com" && window.location.pathname.match(/u|videos|liked|starred|archive|folder/g) !== null)
	){//增加instapaper
		//$floatBtn.show();
		$floatBtn.removeClass("hidden");
	}
	
	//绑定滚动列表时更新mask层高度，以适应动态加载的内容
	$(window).on("scroll",function(){
		importer.mask.fitScreen();
	})
	

	
});