//main js 
//1. 监听背景脚本信息
//2. 调度页面层显示操作,UI.show,UI.hide,

//init the UI layer element
UI.init();

//add message listener ,receive message from background
function onReceiveExtensionMessage(message,sender,sendResponse){
	
	
	//console.log("[onExtensionMessage] : ",message);
	//UI.init();
	
	//首先判断是否携带user信息,如未携带则显示登录界面，否则执行收藏程序并显示收藏成功操作界面
	if(message.userId === null){

		//set the standby bookmark info for add when user logined
		Bookmark.standby = message;
		
		//show the UI layer, and pass in the message
		UI.hide().showSignin().startTimer();
		
		
		
	}else{
		
		//show UI but waiting for data processing
		UI.hide().restore().showDashboard().triggerSpinnerWaiting().updateProgress({name:"bookmarkSaving"});
		
		//check user info from storage
		chrome.storage.sync.get([DEFAULT_STORAGE_USER_INFO_KEY,DEFAULT_STORAGE_CATEGORY_LIST_KEY],function(storage){
			//console.log(storage)
			//return false;
			var userInfo = storage[DEFAULT_STORAGE_USER_INFO_KEY] ,
				categoryList = storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY];
			
			//if storage has user info and category info ,use them, or retreive data from server, and trigger timer until callback function executed
			if( userInfo && categoryList && userInfo.id === Number(message.userId) ){
				
				//set category list to UI 
				UI.setUserBoard(userInfo).refreshCategoryList(categoryList);
				
				//process adding bookmark
				Bookmark.addBookmark(message,function(result){
					if(!result){
						UI.triggerSpinnerFail(function(){
							UI.updateProgress({name : "networkFailed"})
						})
						return false;
					}
					
					if(result.data !== null){
						Bookmark.newlyBookmarkId = result.data.markId;
						UI.triggerSpinnerReady(function(){
							UI.updateProgress({name:"bookmarkSaved"});
							UI.startTimer();
						})
					}else{
						UI.triggerSpinnerFail(function(){
							UI.updateProgress({name:"bookmarkSaveFail"});
							UI.startTimer();
						})
					}
					
				})
				
			}else{
				User.getUserInfo(message.userId,function(resUserInfo){
					
					//false when server or network down
					if(!resUserInfo){
						UI.triggerSpinnerFail(function(){
							UI.updateProgress({name : "networkFailed"})
						})
						return false;
					}
					
					//res.data contain user info
					var userInfo = resUserInfo.data;
					
					User.requestCategory(userInfo,function(resCategory){
						
						//false when server or network down
						if(!resCategory){
							UI.triggerSpinnerFail(function(){
								UI.updateProgress({name : "networkFailed"})
							})
							return false;
						}
						
						var categoryList = resCategory.data;
						
						var storage = {};
						storage[DEFAULT_STORAGE_USER_INFO_KEY] = userInfo;
						storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY] = categoryList;
						
						chrome.storage.sync.set(storage,function(){
							
							UI.setUserBoard(userInfo).refreshCategoryList(categoryList);
							Bookmark.addBookmark(message,function(result){
								
								if(!result){
									UI.triggerSpinnerFail(function(){
										UI.updateProgress({name : "networkFailed"})
									})
									return false;
								}
								
								Bookmark.newlyBookmarkId = result.data.markId;
								
								UI.triggerSpinnerReady(function(){
									UI.updateProgress({name:"bookmarkSaved"});
									UI.startTimer();
								});
							})
							
						})
						
					})
					
					
				});
			}
			
		})
		
		
	}
	

}
//main on message of extension background
chrome.runtime.onMessage.addListener(onReceiveExtensionMessage);



var OAUTH_LOGIN_WINDOW = null;

//on window message
function receiveSnsOauthMessage(event){

	//console.log("[Bookmark.standby:]",Bookmark);
	
	// For Chrome, the origin property is in the event.originalEvent
	// object.
	var origin = event.origin || event.originalEvent.origin; 
	
	if(origin !== SHOUQU.SITE_URL){
		return false;
	}
	var json = event.data;
	var sns_name = json.snsName;
	var userInfo = json.userInfo;
	var token = json.token;
  
	// ...
	if(OAUTH_LOGIN_WINDOW){
		OAUTH_LOGIN_WINDOW.close();
	}
	
	//console.log("[receiveSnsOauthMessage] userInfo :",userInfo);
	
	
	chrome.runtime.sendMessage(	chrome.runtime.id,
		{
			type : "SET_COOKIE",
			data : {
				name : "userId",
				value : userInfo.id
			}
		}
	);
	chrome.runtime.sendMessage(	chrome.runtime.id,
		{
			type : "SET_COOKIE",
			data : {
				name : "token",
				value : token
			}
		}
	);
	chrome.runtime.sendMessage(	chrome.runtime.id,
		{
			type : "SET_COOKIE",
			data : {
				name : "thirdParty",
				value : 1
			}
		}
	);
	
	//set the user nick and avatar at the first time
	UI.setUserBoard(userInfo);
	
	//show ui waiting 
	if(Bookmark.standby !== null){
		UI.hide().restore()
			.showDashboard()
			.triggerSpinnerWaiting()
			.updateProgress({name:"bookmarkSaving"});
	}else{
		UI.hide().restore()
			.showDashboard()
			.triggerSpinnerWaiting()
			.updateProgress({name : "loginLoading"})
	}
		

	//requst user's category list 
	User.requestCategory(userInfo,function(resultCategory){
		
		//false when server or network down
		if(!resultCategory){
			UI.triggerSpinnerFail(function(){
				UI.updateProgress({name : "networkFailed"})
			})
			return false;
		}
		
		var categoryList = resultCategory.data;

		//set storage
		var storage = {};
		storage[DEFAULT_STORAGE_USER_INFO_KEY] = userInfo;
		storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY] = categoryList
		chrome.storage.sync.set(storage);
		
		UI.refreshCategoryList(categoryList);
		
		//add bookmark or show the login success message only
		if(Bookmark.standby !== null){
			
			Bookmark.standby.userId = userInfo.id;
			Bookmark.addBookmark(Bookmark.standby,function(resultAddBookmark){
				
				if(!resultAddBookmark){
					UI.triggerSpinnerFail(function(){
						UI.updateProgress({name : "networkFailed"})
					})
					return false;
				}
		
				Bookmark.newlyBookmarkId = resultAddBookmark.data.markId;
				Bookmark.standby = null;
				UI.triggerSpinnerReady(function(){
					UI.updateProgress({name:"bookmarkSaved"});
					UI.startTimer();
				})
			})
			
		}else{
			//console.log(UI.hide())
			UI.triggerSpinnerReady(function(){
					UI.updateProgress({name:"loginSuccess"});
					UI.startTimer();
				})
			
		}
		
		
	});
  
	
}
window.addEventListener("message", receiveSnsOauthMessage, false);


//OAUTH_LOGIN_WINDOW close event
// //if(OAUTH_LOGIN_WINDOW){
	// OAUTH_LOGIN_WINDOW.onclose = function(){
		// console.log(OAUTH_LOGIN_WINDOW)
	// }
// //}


//register global ajax start and stop
jQuery(document).ajaxStart(function(){
	UI.ajax = 1;
})
jQuery(document).ajaxStop(function(){
	UI.ajax = 0;
})