const UI = {
	$instance : null,
	lastCategoryOrderId : 0,
	timer : null,
	ajax : 0,
	init : function(){
		var html = 
			'<div id="'+ CONTENT_SIGNIN_LAYER_ID +'" class="animated hidden fadeIn">\
				<div class="logo-wrap">\
					<img src="'+ chrome.runtime.getURL('images/logo@2x.png') +'" class="login-logo" />\
				</div>\
				<form id="login_form">\
					<input type="text" id="login_user_phone" placeholder="'+ chrome.i18n.getMessage("loginInputPhonePlaceholder") +'" />\
					<input type="password" id="login_password" placeholder="'+ chrome.i18n.getMessage("loginInputPasswordPlaceholder") +'" />\
					<div id="login_tip" ><span class="warn"></span></div>\
					<div class="login-button-wrap">\
						<button class="login-button" id="login_confirm">'+ chrome.i18n.getMessage("loginButtonText") +'</button>\
						<span class="login-loading-wrap"><img class="login-loading-image" src="'+ chrome.runtime.getURL('images/loading.gif') +'" /></span>\
					</div>\
				</form>\
				<div id="third_part_login">\
					<div class="third-part-login-title-bar">\
						<i class="half-line"></i>\
						<span class="third-part-login-title">'+ chrome.i18n.getMessage("snsLoginTitle") +'</span>\
						<i class="half-line"></i>\
					</div>\
					<div class="sns-logo-wrap">\
						<img id="wechat_login" src="'+ chrome.runtime.getURL('images/wechat@2x.png') +'" title="'+ chrome.i18n.getMessage("wechatLoginTip") +'" />\
						<img id="qq_login" src="'+ chrome.runtime.getURL("images/qq@2x.png") +'" title="'+ chrome.i18n.getMessage("qqLoginTip") +'" />\
						<img id="weibo_login" src="'+ chrome.runtime.getURL("images/sina@2x.png") +'" title="'+ chrome.i18n.getMessage("weiboLoginTip") +'" />\
					</div>\
				</div>\
			</div>\
			<div id="'+ CONTENT_DASHBOARD_LAYER_ID +'" class="animated hidden fadeIn">\
				<div class="collect-head">\
					<div id="user_info" >\
						<img class="user-avatar" src="'+ DEFAULT_AVATAR_URL +'" />\
						<span class="user-name"></span>\
					</div>\
					<a href="#" class="close"><img class="close-img" src="'+ chrome.runtime.getURL('images/close.png') +'" width="12" height="12" /></a>\
				</div>\
				<div class="collect-body" id="screen">\
					<div id="progress_info" class="visible">\
						<div id="progress_status">\
							<div class="sq-spinner">\
								<div class="sq-spinner-wrap">\
									<img id="spin_img_ok" src="'+chrome.runtime.getURL('images/check-1.png')+'" class="sq-spinner-img-ok hidden" />\
									<img id="spin_img_fail" src="'+chrome.runtime.getURL('images/exclaim.png')+'" class="sq-spinner-img-fail hidden" />\
									<svg id="sq_spinner_shape" class="animate-rotate">\
										<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\
											<circle id="sq_spinner_circle" class="" stroke="#dddddd" stroke-width="2" sketch:type="MSShapeGroup" cx="18" cy="18" r="17"></circle>\
										</g>\
									</svg>\
								</div>\
							</div>\
						</div>\
						<div id="progress_text"></div>\
					</div>\
					<div id="logout_info">\
						<div class="logout-links">\
							<a href="'+ DEFAULT_SITE_URL +'" id="open_shouqu" target="_blank">'+chrome.i18n.getMessage("openShouquLinkText")+'</a>\
							<span>|</span>\
							<a href="#" id="logout_confirm">'+chrome.i18n.getMessage("logoutBtnText")+'</a>\
						</div>\
					</div>\
				</div>\
				<div class="collect-foot">\
					<div id="operation_btn_group">\
						<a class="link-website" target="_blank" href="'+ DEFAULT_SITE_URL +'">'+ chrome.i18n.getMessage("menuOpenShouquLink") +'</a>\
						<a id="delete_mark" class="delete-mark" href="#">'+ chrome.i18n.getMessage("menuDeleteBookmark") +'</a>\
						<a id="select_category" class="select-category" href="#">'+ chrome.i18n.getMessage("menuSelectCategory") +'</a>\
						<a id="set_private" class="set-private" href="#" data-private-status="0">'+ chrome.i18n.getMessage("menuSetAsPrivate") +'</a>\
					</div>\
					<div id="category_info" class="animated">\
						<div id="category_list_wrap"><ul id="category_list"></ul></div>\
						<div id="create_category_layer">\
							<input type="text" id="category_name" placeholder="'+ chrome.i18n.getMessage("createCategoryPlaceholder") +'"/>\
							<span id="cancel_create_category">'+ chrome.i18n.getMessage("createCategoryCancelText") +'</span>&nbsp;\
							<span id="confirm_create_category">'+ chrome.i18n.getMessage("createCategoryConfirmText") +'</span>\
						</div>\
						<div id="change_category_foot">\
							<span id="confirm_change_category">'+ chrome.i18n.getMessage("buttonTextConfirmChangeCategory") +'</span>\
						</div>\
					</div>\
				</div>\
			</div>';
		//$(html).appendTo('body');
		if($(document.documentElement).find("#" + CONTENT_SIGNIN_LAYER_ID ).length === 0 && $(document.documentElement).find("#" + CONTENT_DASHBOARD_LAYER_ID ).length === 0){
			$(html).appendTo(document.documentElement)
		}
		
		//set instance refrence as a jQuery object
		this.$instance = {
			signin : $("#" + CONTENT_SIGNIN_LAYER_ID ),
			dashboard : $("#" + CONTENT_DASHBOARD_LAYER_ID )
		};
		
		this.bindEvent();
		
		return this;
	},
	destroy: function(){
		this.$instance.signin.remove();
		this.$instance.dashboard.remove();
	},
	hide: function(){
		this.$instance.signin.addClass("hidden");
		this.$instance.dashboard.addClass("hidden");
		
		return this;
	},
	restore : function(){

		var dashboard = this.$instance.dashboard;
		if(!dashboard.hasClass("hidden")){
			dashboard.find("#progress_text").text(chrome.i18n.getMessage("progressBookmarkSaving"));
			dashboard.find("#category_info").hide();
			dashboard.find("#create_category_layer").removeClass("visible");
			dashboard.find("#category_list li.category-item").removeClass("selected");
			dashboard.find("#set_private").data("private-status",0);
			dashboard.find("#spin_img_ok").addClass("hidden");
			dashboard.find("#spin_img_fail").addClass("hidden");
		}
		
		var signin = this.$instance.signin;
		if(!signin.hasClass("hidden")){
			signin.find("#login_form")[0].reset();
			signin.find(".login-loading-wrap").hide();
			signin.find(".warn").text("");
		}
		
		if(this.timer !== null){
			this.clearTimer();
		}
		
		this.showProgress();
		
		return this;
	},
	startTimer : function(){
		var _this = this;
		if(this.timer === null){
			this.timer = setTimeout(function(){
				//_this.restore().hide();
			},5000);
			//console.log("new timer started : ",this.timer);
		}
		
		return this;
	},
	clearTimer : function(){

		clearTimeout(this.timer);
		this.timer = null;
		//console.log("timer cleared : ",this.timer);

		return this;
	},
	showSignin : function(){
		this.$instance.signin.removeClass("hidden")//.addClass("fadeIn");
		
		return this;
	},
	showDashboard : function(){
		this.$instance.dashboard.removeClass("hidden")//.addClass("fadeIn");
		//console.log("right top element:",document.elementFromPoint(document.documentElement.clientWidth - 12,12))
		return this;
	},
	setUserBoard : function(userInfo){
		this.$instance.dashboard.find(".user-avatar").attr("src",userInfo.headPic);
		this.$instance.dashboard.find(".user-name").text(userInfo.nickname);
		return this;
	},
	refreshCategoryList : function(data){
		var $list = this.$instance.dashboard.find("#category_list");
		var html = '';
		for(var i = 0,len = data.length; i < len; i++){
			html += '<li class="category-item" id="'+ data[i].id +'"><span>'+ data[i].name +'</span></li>'
		}
		html += '<li class="add-category" id="add_category" title="'+ chrome.i18n.getMessage("buttonTitleAddCategory") +'"><span>+</span></li>';
		$list.html(html);
		return this;
	},
	addCategoryItem : function(category_name,category_id,callback){
		var $addCategory = this.$instance.dashboard.find("li.add-category");
		var html = '<li class="category-item" id="'+ category_id +'"><span>'+ category_name +'</span></li>';
		$(html).insertBefore($addCategory);
		if(callback) callback();
		return this;
	},
	triggerSpinnerReady : function(callback){
		var dashboard = this.$instance.dashboard;
		dashboard.find("#spin_img_ok").addClass("hidden");
		dashboard.find("#spin_img_fail").addClass("hidden");
		dashboard.find("#sq_spinner_circle").removeClass().hide().show().addClass("animate-ready");
		dashboard.find("#sq_spinner_circle").bind("animationend",function(){//remove class failed
			dashboard.find("#spin_img_ok").removeClass("hidden");
			dashboard.find("#spin_img_fail").addClass("hidden");
			callback()
		});
		
		return this;
	},
	triggerSpinnerFail : function(callback){
		var dashboard = this.$instance.dashboard;
		dashboard.find("#spin_img_fail").addClass("hidden");
		dashboard.find("#spin_img_ok").addClass("hidden");
		dashboard.find("#sq_spinner_circle").removeClass().hide().show().addClass("animate-ready");
		dashboard.find("#sq_spinner_circle").bind("animationend",function(){//remove class failed
			dashboard.find("#spin_img_ok").addClass("hidden");
			dashboard.find("#spin_img_fail").removeClass("hidden");
			callback()
		});
		
		return this;
	},
	triggerSpinnerWaiting : function(){
		var dashboard = this.$instance.dashboard;
		dashboard.find("#sq_spinner_circle").removeClass().hide().show().addClass("animate-waiting");
		return this;
	},
	toggleProgress : function(){
		this.$instance.dashboard.find("#progress_info").toggleClass("visible");
		this.$instance.dashboard.find("#logout_info").toggleClass("visible");
		return this;
	},
	showProgress : function(){
		this.$instance.dashboard.find("#progress_info").addClass("visible");
		this.$instance.dashboard.find("#logout_info").removeClass("visible");
		return this;
	},
	clearProgress : function(){
		this.$instance.dashboard.find("#progress_text").text("");
		return this;
	},
	updateProgress : function(progress){

		var name = progress.name,
			data = progress.data,
			status_text = "";
		switch(name){
			case "categoryChanged":
				if(data.length == 1){
					status_text = chrome.i18n.getMessage("progressChangeCategoryTo") + data[0]
				}else{
					status_text = chrome.i18n.getMessage("progressChangeCategoryTo") + data.length + chrome.i18n.getMessage("progressCategoryCountText")
				}
				break;
			case "categoryChangeFail":
				status_text = chrome.i18n.getMessage("progressBookmarkInvalid");
				break;
			case "bookmarkDeleting":
				status_text = chrome.i18n.getMessage("progressBookmarkDeleting");
				break;
			case "bookmarkDeleted":
				status_text = chrome.i18n.getMessage("progressBookmarkDeleted");
				break;
			case "bookmarkDeleteFail":
				status_text = chrome.i18n.getMessage("progressBookmarkInvalid");
				break;
			case "bookmarkPrivateStatusChanged" : 
				var private_status_text = ( data == 1 ? chrome.i18n.getMessage("bookmarkPrivateStatusTrue") : chrome.i18n.getMessage("bookmarkPrivateStatusFalse") );
				status_text = chrome.i18n.getMessage("progressSetBookmarkTo") + private_status_text;
				break;
			case "bookmarkPrivateStatusChangeFail":
				status_text = chrome.i18n.getMessage("progressBookmarkInvalid");
				break;
			case "bookmarkSaved":
				status_text = chrome.i18n.getMessage("progressBookmarkSaved");
				break;
			case "bookmarkSaving":
				status_text = chrome.i18n.getMessage("progressBookmarkSaving");
				break;
			case "bookmarkSaveFail":
				status_text = chrome.i18n.getMessage("progressBookmarkInvalid");
				break;
			case "loginLoading":
				status_text = chrome.i18n.getMessage("progressSignInLoading");
				break;
			case "loginSuccess" :
				status_text = chrome.i18n.getMessage("progressLoginSuccess");
				break;
			case "signingOut" :
				status_text = chrome.i18n.getMessage("progressLogingOut");
				break;
			case "signOutSuccess" :
				status_text = chrome.i18n.getMessage("progressLogoutSuccess");
				break;
			case "networkFailed" : 
				status_text = chrome.i18n.getMessage("progressNetworkFailed");
				break;
		}
		

		this.$instance.dashboard.find("#progress_text").text(status_text);
		
		return this;
	},
	bindEvent : function(){
		var $signin = this.$instance.signin,
			$dashboard = this.$instance.dashboard;
		var _this = this;
		
		
		//user name input focus
		$signin.find("#login_form input").bind("focus",function(){
			$signin.find(".login-loading-wrap").hide();
			$signin.find(".warn").text("");
			$(this).addClass("focused");
			_this.clearTimer();
		});
		$signin.find("#login_form input").bind("blur",function(){
			$(this).removeClass("focused");
		});
		
		//sns account sign in 
		$signin.find("#wechat_login").bind("click",function(){
			User.wechatLogin();
		});
		$signin.find("#weibo_login").bind("click",function(){
			User.weiboLogin();
		});
		$signin.find("#qq_login").bind("click",function(){
			User.qqLogin();
		});
		
		//login button click
		$signin.find("#login_confirm").bind("click",function(e){
			e.preventDefault();
			
			var $phone = $signin.find("#login_user_phone"),
				$password = $signin.find("#login_password"),
				$warn = $signin.find(".warn"),
				$login_loading_wrap = $signin.find(".login-loading-wrap"),
				$form = $signin.find("#login_form")
				;
			
			var phone = $phone.val();
			var password = $password.val();
			
			$phone.blur();
			$password.blur();
			
			
			if(phone == "" || password ==""){
				$warn.text(chrome.i18n.getMessage("warnInvalidLoginParameter"));
				return false;
			}
			
			//show loading 
			$login_loading_wrap.show();
			
			
			//retreive user info and category list from server when signin and update the storage,
			//DO NOT use storage data directly, because it may be empty or out of date
			User.loginRequest(phone,password,function(result){
				
				if(!result){
					$warn.text(chrome.i18n.getMessage("progressNetworkFailed"))
					return false;
				}else if(result.code !== 200){
					$warn.text(chrome.i18n.getMessage("warnInvalidUser"))
					return false;
				}else{
					var userInfo = result.data;
					
					//set cookie 
					chrome.runtime.sendMessage(	chrome.runtime.id,
						{
							type : "SET_COOKIE",
							data : {
								name : "userId",
								value : userInfo.id
							}
						}
					);
					
					var token = result.token;
					chrome.runtime.sendMessage(	chrome.runtime.id,
						{
							type : "SET_COOKIE",
							data : {
								name : "token",
								value : token
							}
						}
					);
					
					
					//reset the form
					$login_loading_wrap.hide();
					$form[0].reset();
					
					//update user avatar and name and show wating
					_this.setUserBoard(userInfo).restore().hide().showDashboard().showProgress().triggerSpinnerWaiting();
					
					
					//show ui waiting text
					if(Bookmark.standby !== null){
						_this.updateProgress({name:"bookmarkSaving"});
					}else{
						_this.updateProgress({name : "loginLoading"})
					}
					

					//request category list
					User.requestCategory(userInfo,function(resultCategory){
						
						//network or server fail
						if(!resultCategory){
							_this.triggerSpinnerFail(function(){
								_this.updateProgress({name : "networkFailed"})
							})
							return false;
						}
						
						var categoryList = resultCategory.data;
				
						//set storage
						var storage = {};
						storage[DEFAULT_STORAGE_USER_INFO_KEY] = userInfo;
						storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY] = categoryList
						chrome.storage.sync.set(storage);
						
						//refresh category on dashboard
						_this.refreshCategoryList(categoryList);
						
						if(Bookmark.standby){
							Bookmark.standby.userId = userInfo.id;
							Bookmark.addBookmark(Bookmark.standby,function(resultAddBookmark){
								
								if(!resultAddBookmark){
									_this.triggerSpinnerFail(function(){
										_this.updateProgress({name : "networkFailed"})
									})
									return false;
								}
						
								Bookmark.newlyBookmarkId = resultAddBookmark.data.markId;
								Bookmark.standby = null;
				
								_this.triggerSpinnerReady(function(){
									_this.updateProgress({name : "bookmarkSaved"});
									_this.startTimer();
								});
								
							})
							
						}else{
							_this.triggerSpinnerReady(function(){
								_this.updateProgress({name:"loginSuccess"});
								_this.startTimer();
							})
						}
						
						
					});
						
				}

			})
		});
		
		//category button 
		$dashboard.find("#select_category").bind("click",function(e){
			e.preventDefault();
			//$("#category_info").toggle();
			$dashboard.find("#category_info").slideToggle(200);
		});
		
		//category list item click
		$dashboard.delegate(".category-item","click",function(e){
			$(this).toggleClass("selected");
		});
		
		//category confirm click
		$dashboard.find("#confirm_change_category").bind("click",function(e){
			
			e.preventDefault();
			
			if(Bookmark.newlyBookmarkId === null){
				_this.restore().showProgress().triggerSpinnerFail(function(){
					_this.updateProgress({
						name : "categoryChangeFail"
					});
				});
				return false;
			}
		
			var selected_category_ids = [],selected_category_names = [];
			$dashboard.find("#category_list li.category-item.selected").each(function(){
				selected_category_ids.push($(this).attr("id"));
				selected_category_names.push($(this).text());
			});
			
			if(selected_category_ids.length == 0){
				$dashboard.find("#category_info").slideUp(200);
				return false;
			}
			chrome.storage.sync.get(DEFAULT_STORAGE_USER_INFO_KEY,function(resultUserInfo){
				
				var userInfo  = resultUserInfo[DEFAULT_STORAGE_USER_INFO_KEY];
				
				$dashboard.find("#category_info").slideUp(200);
				$dashboard.find("#category_list li.category-item.selected").removeClass("selected");
				
				_this.clearProgress().showProgress().triggerSpinnerWaiting().updateProgress({name : "bookmarkSaving"});
				Bookmark.updateBookmarkCategory(selected_category_ids,userInfo,function(result){
					
					if(result === null){
						//console.warn("bookmark id invalid");
						_this.triggerSpinnerFail(function(){
							_this.updateProgress({name : "networkFailed"})
						})
						return false;
					}else{
						
						_this.triggerSpinnerReady(function(){
							_this.updateProgress({
								name : "categoryChanged",
								data : selected_category_names
							})
						})
						
							
					}
				})
			})
			
		});
	
		//bind delete bookmark click
		$dashboard.find("#delete_mark").bind("click",function(e){
			e.preventDefault();
			
			if(Bookmark.newlyBookmarkId === null){
				_this.restore().showProgress().triggerSpinnerFail(function(){
					_this.updateProgress({
						name : "bookmarkDeleteFail"
					});
				});
				return false;
			}
			chrome.storage.sync.get(DEFAULT_STORAGE_USER_INFO_KEY,function(resultUserInfo){
				
				var userInfo  = resultUserInfo[DEFAULT_STORAGE_USER_INFO_KEY];
				
				_this.clearProgress().showProgress().triggerSpinnerWaiting().updateProgress({name : "bookmarkDeleting"});
				
				Bookmark.deleteCurrentBookmark(userInfo,function(result){
					if(result === null){
						//console.warn("bookmark id invalid");
						_this.triggerSpinnerFail(function(){
							_this.updateProgress({name : "networkFailed"})
						})
						return false;
					}else{
						
						Bookmark.newlyBookmarkId = null;
						
						_this.triggerSpinnerReady(function(){
							_this.updateProgress({name : "bookmarkDeleted"})
						});

						
					}
				})
			});

			
		});
		
		//bind change private status
		$dashboard.find("#set_private").bind("click",function(e){
			e.preventDefault();
			
			if(Bookmark.newlyBookmarkId === null){
				_this.restore().showProgress().triggerSpinnerFail(function(){
					_this.updateProgress({
						name : "bookmarkPrivateStatusChangeFail"
					})
				});
				return false;
			}
			
			var $this = $(this);
			var private_status = 1 - $(this).data("private-status");//切换当前书签私密状态
			$this.data("private-status",private_status);
			$this.text(private_status ?  chrome.i18n.getMessage("menuSetAsPublic") : chrome.i18n.getMessage("menuSetAsPrivate"))
			
			chrome.storage.sync.get(DEFAULT_STORAGE_USER_INFO_KEY,function(storage){
				
				var userInfo  = storage[DEFAULT_STORAGE_USER_INFO_KEY];
				
				_this.clearProgress().showProgress().triggerSpinnerWaiting().updateProgress({name : "bookmarkSaving"});
				
				Bookmark.switchCurrentBookmarkPrivate(private_status,userInfo,function(result){
					if(result === null){
						//console.warn("bookmark id invalid");
						_this.triggerSpinnerFail(function(){
							_this.updateProgress({name : "networkFailed"})
						})
						return false;
					}else{
						_this.triggerSpinnerReady(function(){
							_this.updateProgress({
								name : "bookmarkPrivateStatusChanged",
								data : private_status
							});
						});
						
					}
				})
				
			});
			
		})
	
		//bind add category button
		$dashboard.delegate("#add_category","click",function(){
			$dashboard.find("#create_category_layer").addClass("visible");
			$dashboard.find("#category_name").focus();
		});
		
		//bind cancel add category
		$dashboard.find("#cancel_create_category").bind("click",function(){
			$dashboard.find("#category_name").val('');
			$dashboard.find("#create_category_layer").removeClass("visible");
		});
		
		//bind create category
		$dashboard.find("#confirm_create_category").bind("click",function(){
			
			var category_name = $dashboard.find("#category_name").val();
			if(!category_name){return false;}
			
			chrome.storage.sync.get([DEFAULT_STORAGE_USER_INFO_KEY,DEFAULT_STORAGE_CATEGORY_LIST_KEY],function(storage){
				
				var userInfo  = storage[DEFAULT_STORAGE_USER_INFO_KEY];
				var categoryList = storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY];
				
				//calculate the lastCategoryOrderId 
				var lastCategoryOrderId = categoryList.length > 0 ? categoryList[categoryList.length - 1].orderid : 0;
				
				//add new category on server and refresh the UI
				//then update the storage by another categoryList requesting
				User.addCategory(category_name,lastCategoryOrderId,userInfo,function(res){
					if(res.code === 200){
						
						let new_category_id = res.data.id;
						
						_this.addCategoryItem(category_name,new_category_id,function(){
							$dashboard.find("#"+new_category_id).addClass("selected");
						});
						
						$dashboard.find("#category_name").val('');
						$dashboard.find("#create_category_layer").removeClass("visible");
						
						User.requestCategory(userInfo,function(resultCategory){
							
							let categoryList = resultCategory.data;
							let storage = {};
							storage[DEFAULT_STORAGE_CATEGORY_LIST_KEY] = categoryList
							chrome.storage.sync.set(storage);
							
						});
					}
					
				})
				
			});
			
		});
	
		//bind user board click
		$dashboard.find("#user_info").bind("click",function(){
			_this.toggleProgress();
		});
		
		//bind sign out click
		$dashboard.find("#logout_confirm").bind("click",function(e){
			e.preventDefault();
			
			//clear user cookie from browser and clear all storage 
			User.clearUserInfo();
			
			//clear bookmark standby
			Bookmark.standby = null;
			Bookmark.newlyBookmarkId = null;
			
			//show a signing out animation and switch to sign in UI when animation end;
			_this.restore().updateProgress({name:"signingOut"}).triggerSpinnerReady(function(){
				_this.updateProgress({name:"signOutSuccess"});
				//_this.restore().hide().showSignin();
			});
	
			
		});
		
		//close pop page
		$dashboard.find(".close").bind("click",function(e){
			e.preventDefault();
			if(_this.timer !== null){
				_this.clearTimer()
			}
			_this.hide().restore();
		});
		
		//bind document click inorder to hide the dashboard or signin board
		$(document).bind("click",function(event){
			if($(event.target).parents("#" + CONTENT_DASHBOARD_LAYER_ID).length === 0 && $(event.target).parents("#" + CONTENT_SIGNIN_LAYER_ID).length === 0){
				if(_this.timer !== null){
					_this.clearTimer()
				}
				_this.restore().hide();
				
			}
		});
		
		//IF THERE IS NO MOUSE EVENT ,FOR EXAMPLE THE CURSOR IS JUST ON THE TOP OF THE DASHBOARD WITHOUT ANY MOVING,
		//THE TIMER WILL START AND THE DASHBOARD WILL HIDE,THIS IS NOT FINE.
		//clear timer to hold the UI when mouse enter, and release holding when mouse leave
		$dashboard.on("mouseenter",function(event){
			if(_this.timer !== null){
				_this.clearTimer();
			}
		});
		$dashboard.on("mousemove",function(event){
			if(_this.timer !== null){
				_this.clearTimer();
			}
		});
		$dashboard.on("mouseleave",function(event){
			if(_this.timer === null && _this.ajax === 0){
				_this.startTimer();
			}
		});
		$signin.on("mouseenter",function(event){
			if(_this.timer !== null){
				_this.clearTimer();
			}
		});
		$signin.on("mousemove",function(event){
			if(_this.timer !== null){
				_this.clearTimer();
			}
		});
		$signin.on("mouseleave",function(event){
			var valid = !OAUTH_LOGIN_WINDOW || OAUTH_LOGIN_WINDOW && OAUTH_LOGIN_WINDOW.window === null;
			valid = valid && ($signin.find("#login_form input.focused").length === 0)
			if(valid){
				if(_this.timer === null && _this.ajax === 0){
					_this.startTimer();
				}
			}
		});
		
	
		//bind category list scrolling
		// $dashboard.find("#category_list")[0].onmousewheel = function(e){
			// $dashboard.find("#category_list")[0].scrollTop -= e.wheelDelta;
		// }
		
		//init the category list scroll bar 
		$("#category_list_wrap").slimScroll({
			height: '210px',
			size: '4px',
			position: 'right',
			color: '#999',
			alwaysVisible: false,
			distance: '0px',
			railVisible: true,
			railColor: 'none',
			railOpacity: 0.3,
			wheelStep: 10,
			allowPageScroll: true,
			disableFadeOut: false
		})
	}

	
};