var User = {

	currentUser : null,

	loginRequest : function(phone,pwd,callback){
		var _this = this;
		var options = {
			url:API_LOGIN,
			//url:"http://dev.shouqu.me/api_service/api/v1/user/login",
			type:'POST',
			data:{
				phone:phone,
				password:pwd
			},
			success:function(res){
				if(callback) callback(res)
			},
			error:function(jqXHR,textStatus,errorThrown){
				console.log("User->loginRequest:",jqXHR);
				callback(null);
			}
		};
		commonAjax(options);
	},
	getUserInfo : function(userId,callback){
		var _this = this;
		var options = {
			url:API_GET_USER_INFO,
			type:'POST',
			data:{
				userId : userId
			},
			success:function(res){
				if(callback) callback(res);
			},
			error:function(jqXHR,textStatus,errorThrown){
				console.log("User->getUserInfo:",jqXHR);
				callback(false)
			}
		}
		commonAjax(options);
	},
	clearUserInfo: function(){
		chrome.runtime.sendMessage(	chrome.runtime.id,
			{
				type : "DELETE_COOKIE",
				data : {
					name : "userId"
				}
			}
		);chrome.runtime.sendMessage(	chrome.runtime.id,
			{
				type : "DELETE_COOKIE",
				data : {
					name : "token"
				}
			}
		);chrome.runtime.sendMessage(	chrome.runtime.id,
			{
				type : "DELETE_COOKIE",
				data : {
					name : "thirdParty"
				}
			}
		);
	},
	wechatLogin:function(){
		var url = "https://open.weixin.qq.com/connect/qrconnect", 
			iWidth = 500,
		    iHeight = 485;
		url += "?appid=wx289cb01bc0645e9a";
		url += "&redirect_uri=" + encodeURIComponent("https://shouqu.me/oauth/wechat/ext_chrome.html");
		url += "&response_type=access_token";
		url += "&scope=snsapi_login";
		url += "&state=STATE";
		url += "#wechat_redirect";
		
		OAUTH_LOGIN_WINDOW = window.open(url, "oauth_login_window", "width=" + iWidth + ",height=" + iHeight + ",toolbar=no,menubar=no,resizable=no,status=no,left=" + (screen.width - iWidth) / 2 + ",top=" + (screen.height - iHeight) / 2);
		if (OAUTH_LOGIN_WINDOW) {
			OAUTH_LOGIN_WINDOW.focus()
		}
	},
	qqLogin:function(){
		var url = "https://graph.qq.com/oauth2.0/authorize",
			iWidth = 600,
			iHeight = 415;
		url += "?response_type=code";
		url += "&client_id=101318943";
		url += "&state=shouqu"
		url += "&redirect_uri=" + encodeURIComponent("https://shouqu.me/oauth/qq/" + "?from=ext_chrome") ;

		OAUTH_LOGIN_WINDOW = window.open(url, "oauth_login_window", "width=" + iWidth + ",height=" + iHeight + ",toolbar=no,menubar=no,resizable=no,status=no,left=" + (screen.width - iWidth) / 2 + ",top=" + (screen.height - iHeight) / 2);
		if (OAUTH_LOGIN_WINDOW) {
			OAUTH_LOGIN_WINDOW.focus()
		}
	},
	weiboLogin:function(menuItemId){

		var url = "https://api.weibo.com/oauth2/authorize",
		iWidth = 600,
		iHeight = 415;
		url += "?client_id=2396930018";
		url += "&response_type=code";
		url += "&redirect_uri=" + encodeURIComponent("https://shouqu.me/oauth/weibo/ext_chrome.html" + "?menu_item_id=" + menuItemId) ;
		OAUTH_LOGIN_WINDOW = window.open(url, "oauth_login_window", "width=" + iWidth + ",height=" + iHeight + ",toolbar=no,menubar=no,resizable=no,status=no,left=" + (screen.width - iWidth) / 2 + ",top=" + (screen.height - iHeight) / 2);
		if (OAUTH_LOGIN_WINDOW) {
			OAUTH_LOGIN_WINDOW.focus()
		}
		return
	},
	requestCategory : function(userInfo,callback){
		var _this = this;
		var options = {
			url:API_REQUEST_CATEGOTY,
			data:{
				userId:userInfo.id,
				order:(userInfo.categorySort == 0 ? "orderid" : "amount")
			},
			success:function(res){
				if(callback) callback(res);
			},
			error:function(jqXHR,textStatus,errorThrown){
				console.log("User->requestCategory:",jqXHR,textStatus);
				callback(false)
			}
		};
		
		commonAjax(options)
	},
	addCategory : function(category_name,last_category_order,userInfo,callback){

		var _this = this;
		var data_obj = {
			id:Math.random().toString(36).substr(2,8)+new Date().getTime()*1000,
			userId:userInfo.id,
			parentid:0,
			name:category_name,
			updatetime:new Date().getTime()*1000,
			dataActive:1,
			orderid:last_category_order + 1
		}

		var data_str = '['+JSON.stringify(data_obj)+']';
		var options = {
			url:API_CREATE_CATEGORY,
			data:{
				userId:userInfo.id,
				data : data_str
			},
			success:function(res){
				//if(callback) callback(res);//res.data == null
				if(res.code === 200){
					var result = Object.assign({},data_obj,{
						pinyin:null,
						privated:null,
						autoShareKindle : null,
						amount: 0
					});
					res.data = result
					if(callback){callback(res)}
				}
				
			},
			error:function(jqXHR,textStatus,errorThrown){
				console.log("User->addCategory:",jqXHR,textStatus);
				callback(false)
			}
		};
		
		commonAjax(options)
	},
}